#ifndef __USBIO_FAMILY__
#define __USBIO_FAMILY__
//===========================================================================
// Km2Net USB-IO Family 制御関数ソース
//
//
//===========================================================================

//共通定義 ---------------------------------------------------------
#define global KM2USBIO_OK						0
#define global KM2USBIO_ERROR					-1
#define global KM2USBIO_ERROR1					-1
#define global KM2USBIO_ERROR2					-2
#define global KM2USBIO_ERROR3					-3
#define global KM2USBIO_ERROR4					-4
#define global KM2USBIO_USBIO_CNT_MAX			16
#define global KM2USBIO_VENDOR_ID				0x1352
#define global KM2USBIO_PRODUCT_ID				0x0121
//Product ID = 0x0110:USB-FSIO(KIT) 0x0111:USB-FSIO30   0x0120:USB-IO2.0    0x0121:USB-IO2.0(AKI)

dim giUsbIoH@,KM2USBIO_USBIO_CNT_MAX	//USB-IO HIDハンドル
giUsbIoCnt@ = 0							//USB-IO 数

//USB-FSIO用直接制御用 ---------------------------------------------------------
sdim gDirectSend@, 64+1					//USB-FSIO 直接送信データ
sdim gDirectRecv@, 64+1					//USB-FSIO 直接受信データ

//USB-IO用モジュール ---------------------------------------------------------
#module "UsbIoCtl"

iUsbIoSendCnt = 0

//kernel32.dll 定義 ---------------------------------------------------------
#uselib "kernel32.dll"

#func CreateFile	"CreateFileA"	int, int, int, int, int, int, int
#func CloseHandle	"CloseHandle"	int
#func WriteFile		"WriteFile"		int, int, int, int, int
#func ReadFile 		"ReadFile"		int, int, int, int, int

#func GetLastError "GetLastError"
#func FormatMessage "FormatMessageA" int, int, int, int, int, int, int

#define INVALID_HANDLE_VALUE	-1
#define GENERIC_READ     		0x80000000
#define GENERIC_WRITE    		0x40000000
#define FILE_SHARE_READ  		0x1
#define FILE_SHARE_WRITE 		0x2
#define OPEN_EXISTING    		0x3
#define OPEN_ALWAYS      		0x4
#define FORMAT_MESSAGE_FROM_SYSTEM		0x1000
#define FORMAT_MESSAGE_IGNORE_INSERTS	0x200


//hid.dll 定義 ---------------------------------------------------------
#uselib "hid.dll"
#func HidD_GetHidGuid "HidD_GetHidGuid" int
#func HidD_GetAttributes "HidD_GetAttributes" int, int

//setupapi.dll 定義 ---------------------------------------------------------
#uselib "setupapi.dll"

#func SetupDiGetClassDevs "SetupDiGetClassDevsA" int, int, int, int
#func SetupDiEnumDeviceInterfaces "SetupDiEnumDeviceInterfaces" int, int, int, int, int
#func SetupDiGetDeviceInterfaceDetail "SetupDiGetDeviceInterfaceDetailA" int, int, int, int, int, int

#define DIGCF_PRESENT			0x02
#define DIGCF_DEVICEINTERFACE	0x10



//---------------------------------------------------------
//関数		：USB-IO Family オープン
//概要		：接続中のUSB-IOを全てオープン
//戻り値	：発見したUSB-IO数　存在しない場合は 0
//---------------------------------------------------------
#deffunc openUsbIo

	iResult			= 0
	iHDEVINFO 		= 0
	iNeeded			= 0
	iDetailData 	= 0
	sDevicePath		= "PathDummy"
	iWkHidH			= 0
	iVID			= 0
	iPID			= 0
	sdim sGUID,16								//16byte
	dim iSECURITY_ATTRIBUTES,3					//12Byte
	sdim sGUID,16								//16byte
	sdim sHIDD_ATTRIBUTES,10					//10byte
	iPHIDP_PREPARSED_DATA = 0					//long	
	sdim sSP_DEVICE_INTERFACE_DATA,28			//28byte

	giUsbIoCnt@ = 0

	memset sGUID,0,16,0
	//HIDデバイスガイド取得
	HidD_GetHidGuid varptr(sGUID)

	//デバイスセットアップ　クラス取得
	SetupDiGetClassDevs varptr(sGuid), 0, 0, (DIGCF_PRESENT | DIGCF_DEVICEINTERFACE)
	iHDEVINFO = stat

	repeat	100,0				//MAX１００デバイス検索
		iWk = 28
		memcpy sSP_DEVICE_INTERFACE_DATA, iWk, 4, 0	//サイズ設定

		//MemberIndex番目のデバイスパスの取得
		SetupDiEnumDeviceInterfaces iHDEVINFO, 0, varptr(sGuid), cnt, varptr(sSP_DEVICE_INTERFACE_DATA)
		iResult = stat
		//デバイス発見
		if (iResult != 0) { 
			//インフォメーションデータの明細バッファ数取得
			SetupDiGetDeviceInterfaceDetail iHDEVINFO, varptr(sSP_DEVICE_INTERFACE_DATA), 0, 0, varptr(iNeeded), 0
			iResult = stat
			iDetailData = iNeeded;
			//メモリ確保
			sdim sPSP_DEVICE_INTERFACE_DETAIL_DATA_A,iNeeded

			//明細データに必要なバッファサイズセット
			iWk = 5
			memcpy sPSP_DEVICE_INTERFACE_DETAIL_DATA_A, iWk, 4, 0	//サイズ設定
			SetupDiGetDeviceInterfaceDetail iHDEVINFO, varptr(sSP_DEVICE_INTERFACE_DATA), varptr(sPSP_DEVICE_INTERFACE_DETAIL_DATA_A), iDetailData, varptr(iNeeded), 0
			iResult = stat
			getstr sDevicePath, sPSP_DEVICE_INTERFACE_DETAIL_DATA_A, 4

			// セキュリティー属性の設定
			iSECURITY_ATTRIBUTES.0 = 12	;サイズ
			iSECURITY_ATTRIBUTES.1 = 0	;
			iSECURITY_ATTRIBUTES.2 = 0	;FALSE

			//取得したデバイスパスを作成する
			CreateFile varptr(sDevicePath), (GENERIC_READ | GENERIC_WRITE), (FILE_SHARE_READ | FILE_SHARE_WRITE), varptr(iSECURITY_ATTRIBUTES), OPEN_EXISTING, 0, 0
			iWkHidH = stat
 			//デバイスパス作成失敗
			if (iWkHidH != INVALID_HANDLE_VALUE) {
				//属性情報のバッファ初期化
				memset sHIDD_ATTRIBUTES, 0, 10, 0
				iWk = 10
				memcpy sHIDD_ATTRIBUTES, iWk, 4, 0	//サイズ設定
				//属性情報の取得
				HidD_GetAttributes iWkHidH, varptr(sHIDD_ATTRIBUTES);
				iVID = (peek(sHIDD_ATTRIBUTES,5) << 8) + peek(sHIDD_ATTRIBUTES,4)
				iPID = (peek(sHIDD_ATTRIBUTES,7) << 8) + peek(sHIDD_ATTRIBUTES,6)
				if (iVID == KM2USBIO_VENDOR_ID@) && (iPID == KM2USBIO_PRODUCT_ID@) && (giUsbIoCnt@ < KM2USBIO_USBIO_CNT_MAX@) {
					giUsbIoH@(giUsbIoCnt@)	= iWkHidH			//USB-IO HIDハンドルセット
					giUsbIoCnt@				= giUsbIoCnt@ + 1	//USB-IO 数カウント
				}
				else{
					/* 対象外のハンドルクローズ */
					CloseHandle varptr(iWkHidH)
				}
			}
		}
		else {
			//これ以上デバイスなし
			break
		} 
	loop
	
	return giUsbIoCnt@


//---------------------------------------------------------
//関数		：USB-IO Family クローズ
//概要		：オープン中のハンドルクローズ
//戻り値	：なし
//---------------------------------------------------------
#deffunc closeUsbIo
	iCloseCnt = 0
	
	for iCloseCnt, 0, giUsbIoCnt@, 1
		CloseHandle giUsbIoH@(iCloseCnt)
		giUsbIoH@(iCloseCnt) = 0
	next

	giUsbIoCnt@ = 0

	return


//---------------------------------------------------------
//関数		：USB-IO Family 直接送受信
//引数		：int iUsbioNo	オープンしたUsbIo 0～
//概要		：直接送受信
//戻り値	：0 OK		0 未満 エラー
//---------------------------------------------------------
#deffunc directSendRecv int iUsbioNo
	dim NumberOfBytesRead

	iUsbIoSendCnt = iUsbIoSendCnt + 1
	if (iUsbIoSendCnt > 0xff) {
		iUsbIoSendCnt = 1
	}
	
	iWrtByte = 0

	poke gDirectSend@, 64, iUsbIoSendCnt
	WriteFile giUsbIoH@(iUsbioNo), varptr(gDirectSend@), 64+1, varptr(iWrtByte), 0

	

	iRetCounter	= 0
	iRetCmd		= 0

	for iWaitRetry, 0, 15, 1
		for iImmediateRetry, 0, 10, 1
//assert
			ReadFile giUsbIoH@(iUsbioNo), varptr(gDirectRecv@), 64+1, varptr(NumberOfBytesRead), 0
			iRetCounter = peek(gDirectRecv@, 64)
//logmes strf("Counter[%d,%d],",iRetCounter ,iCounter)
			if (iRetCounter == iUsbIoSendCnt) {
				return KM2USBIO_OK
			}

		next
		wait 1
	next
	
	return KM2USBIO_ERROR@
	
#global

#endif